Wrong result for curveToLine with max angle 70 on a semicircle

2017-06-19 01:35 PM - Sandro Santilli

Status: Closed

Priority: Normal

Assignee: Sandro Santilli

Category: Geometry

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 24621

Description

This code snippet shows how a MaxAngle:70-degrees linearization of a curve gives a wrong result:

  wkt = QStringLiteral( "CIRCULARSTRING(0 0,100 100,200 0)" );                  

  circularString.reset( dynamic_cast<QgsCircularString *>( QgsGeometryFactory::geomFromWkt( wkt ) ) );

  QVERIFY( circularString.get() );                                              

  lineString.reset( circularString->curveToLine( 70 * M_PI / 180.0 ) );         

  QVERIFY( lineString.get() );                                                  

  //lineString->asWkt();                                                        

std::cout << "XXX --- " << lineString->asWkt().toStdString() << std::endl;

You can see the resulting line here:

http://strk.kbt.io/tmp/qgis-maxangle-70.png

Expected resulting line (obtained via PostGIS ongoing work https://gitlab.com/postgis/postgis/merge_requests/3) is this:

http://strk.kbt.io/tmp/pgis-maxangle-70.png

Related issues:

Related to QGIS Application - Bug report # 16717: curveToLine introduces dupl... Closed 2017-06-17

Associated revisions

Revision 48c95399 - 2017-08-25 11:06 PM - Sandro Santilli

Refactor curveToLine to emit equidistant segments and fix some issues

Fixes #16717

Fixes #16722

Include tests

History

#1 - 2017-06-19 01:35 PM - Sandro Santilli

- Related to Bug report #16717: curveToLine introduces duplicated points added

#2 - 2017-07-21 12:03 PM - Sandro Santilli

- Assignee set to Sandro Santilli

- Status changed from Open to In Progress
#3 - 2017-07-21 10:37 PM - Sandro Santilli

Test for this added to https://github.com/qgis/QGIS/pull/4746

#4 - 2017-08-11 06:28 PM - Sandro Santilli

- Pull Request or Patch supplied changed from No to Yes

The PR now also contains a fix for this bug

#5 - 2017-08-25 11:06 PM - Sandro Santilli

- % Done changed from 0 to 100

- Status changed from In Progress to Closed

Applied in changeset commit:qgis|48c953991e15b56e9e9300ec8007d44ce1c64966.
